=== debian/changelog ===
cmake (2.8.11.1-1~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.

 -- Modestas Vainius <modax@debian.org>  Sat, 29 Jun 2013 12:29:04 +0300

cmake (2.8.11.1-1) unstable; urgency=low

  * New upstream tweak release:
    - this release fixes tests which used to fail when cmake build path
      contained regex metacharacters. As a result, cmake should no longer FTBFS
      on Debian buildds which have '+' symbol in the build path.

 -- Modestas Vainius <modax@debian.org>  Sun, 16 Jun 2013 00:58:09 +0300

cmake (2.8.11-2) unstable; urgency=low

  * Build with BZip2 support, thanks to Pino Toscano for heads up!
  * Bump Standards-Version to 3.9.4: no changes needed.

 -- Modestas Vainius <modax@debian.org>  Sun, 19 May 2013 22:47:11 +0300

cmake (2.8.11-1) unstable; urgency=low

  * New upstream release.
  * Add multiarch-python-include-dirs.diff to support multi-arch capable
    python. Stolen from Ubuntu.
  * FindQt4: define QT_IMPORTS_DIR variable even if it is not present on
    the system (i.e. there are no plugins currently installed). Stolen
    from Ubuntu. Patch qt_import_dir_variable.diff.

 -- Modestas Vainius <modax@debian.org>  Sun, 19 May 2013 12:38:26 +0300

cmake (2.8.11~rc3-1) experimental; urgency=low

  * New upstream release.

 -- Modestas Vainius <modax@debian.org>  Sun, 21 Apr 2013 11:09:05 +0300

cmake (2.8.11~rc1-1) experimental; urgency=low

  * New upstream release. (Closes: #700225)
  * Make cmake recommend make and gcc rather than suggest them.
  * Make cmake suggest codeblocks and eclipse.
  * Drop XMLrpc support. It has been disabled upstream for a while now.
    (Closes: #687326)
  * Bump Standards-Version to 3.9.4: no changes needed.
  * Replace FindBoost_add_-lpthread_#563479.diff patch with a better version
    from upstream BTS and make it apply to current FindBoost.
  * Drop FindPostgreSQL_665721.diff patch, merged upstream.
  * Refresh multiarch_findgtk2_fix.diff patch.

 -- Modestas Vainius <modax@debian.org>  Sat, 16 Mar 2013 20:41:24 +0200
